Public Class Form1

  Private FloodFillColor As Color = Color.Transparent
  Private Image As Image
  Private Bitmap As Cosmologix.Drawing.Bitmap
  Private Tolerance As Single = 0.2

  Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
    If Me.OpenFileDialog1.ShowDialog <> Windows.Forms.DialogResult.OK Then Exit Sub
    LoadImage(Image.FromFile(Me.OpenFileDialog1.FileName))
  End Sub

  Private Sub LoadImage(ByVal Image As Image)
    Try
      Me.Image = Image
      Bitmap = New Cosmologix.Drawing.Bitmap(Image)
      Me.PictureBox1.Image = Image
    Catch ex As Exception
      MsgBox(ex.Message)
    End Try
  End Sub

  Private Sub FloodFill(ByVal X As Integer, ByVal Y As Integer)
    Bitmap.FloodFill(X, Y, Me.FloodFillColor, Me.Tolerance)
    Me.PictureBox1.Image = Bitmap.Bitmap
    Me.PictureBox1.Refresh()
  End Sub

  Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
    LoadImage(My.Resources.testimage)
  End Sub

  Private Sub PictureBox1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
    If Bitmap IsNot Nothing AndAlso e.X <= Bitmap.Width AndAlso e.Y <= Bitmap.Height Then
      FloodFill(e.X, e.Y)
    ElseIf Bitmap Is Nothing Then
      MsgBox("Load an image")
    Else
      MsgBox("Click inside the bounds of the image.")
    End If
  End Sub

  Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    Text = "Click Image to fill with chosen color"
    LoadImage(My.Resources.testimage)

  End Sub

  Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint

    'Creating a new Rectangle as similar width and height of the base form 
    Dim oRAngle As Rectangle = New Rectangle(0, 0, Me.Width, Me.Height)

    'Creating a new Gradient style brush.
    'Change the colors here to get different color combination.
    '"Drawing.Drawing2D.LinearGradientMode.BackwardDiagonal" can be changed accordingly to get different styles like
    'ForwardDiagonal, Horizontal, Vertical.
    Dim oGradientBrush As Brush = New Drawing.Drawing2D.LinearGradientBrush(oRAngle, Color.White, Color.Purple, Drawing.Drawing2D.LinearGradientMode.Vertical)

    'With the help of fillrectangle function drawing rectangle in to form
    e.Graphics.FillRectangle(oGradientBrush, oRAngle)

  End Sub

  Private Sub btnColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnColor.Click
    If Me.ColorDialog1.ShowDialog <> Windows.Forms.DialogResult.OK Then Exit Sub
    Me.FloodFillColor = Me.ColorDialog1.Color
  End Sub

  Private Sub btnTolerance_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTolerance.Click
    Dim Value As String = InputBox("Enter Decimal Value between 0 and 1", "Flood Fill Tolerance", Me.Tolerance.ToString)
    If Value = String.Empty Then Exit Sub
    If Not IsNumeric(Value) Then
      MsgBox("Invalid decimal")
    ElseIf Single.Parse(Value) >= 0 AndAlso Single.Parse(Value) <= 1 Then
      Me.Tolerance = Single.Parse(Value)
    Else
      MsgBox("Enter a Decimal Value between 0 and 1")
    End If
  End Sub

  Private Sub btnTransparent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTransparent.Click
    Me.FloodFillColor = Color.Transparent
  End Sub

  Private Sub btnSpeedTest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSpeedTest.Click
    Dim Start As DateTime = Now
    For Index As Integer = 1 To 1000
      Bitmap = New Cosmologix.Drawing.Bitmap(Me.Image)
      Bitmap.FloodFill(0, 0, Me.FloodFillColor, Me.Tolerance)
    Next
    Dim Elapsed As TimeSpan = Now.Subtract(Start)
    Dim Average As Single = Elapsed.TotalMilliseconds / 1000.0
    MsgBox(String.Format("Average {0} ms per flood fill with chosen settings", Average))
  End Sub
End Class
